> For the complete documentation index, see [llms.txt](https://developer.barchart.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://developer.barchart.com/getting-started/service-types.md).

# Streaming Service Types

When subscribing to market data streams, choose the service level that fits your application.

For example, applications that need updates every 30 seconds can request `REAL_TIME_SNAPSHOT`. Set the snapshot interval with the subscription request.

Review [User Settings](/openfeed-api/user-settings.md) to confirm your available exchanges and service permissions.

### Realtime

The `REAL_TIME` service type streams data as it happens on the exchange. If you are not permissioned for real-time data, Openfeed Streaming downgrades the service to `DELAYED` or rejects the `SubscriptionRequest`.

#### Subscription response example

```protobuf
Sending: subscriptionRequest {
  token: "fe39068e-08fb-43ac-a786-bec6aa42de95"
  service: REAL_TIME
  requests {
    symbol: "^BTCUSD"
    subscriptionType: TRADES
  }
}

...

subscriptionResponse {
  status {
    result: SUCCESS
    service: DELAYED
  }
  symbol: "^BTCUSD"
  marketId: 2616696889477124894
  channelId: 30
  subscriptionType: TRADES
}
```

#### Rejected subscription response example

```protobuf
subscriptionResponse {
  status {
    result: INSUFFICIENT_PRIVILEGES
    message: "Not authorized"
  }
  symbol: "^BTCUSD"
  subscriptionType: DEPTH_PRICE
}
```

### Delayed

The `DELAYED` service type streams data delayed by exchange requirements. Delays vary by exchange, but are generally 10 to 15 minutes behind the real-time market.

Message formats and server behavior remain the same as real-time service.

For control over the update interval, use a [Streaming Snapshot Type](/getting-started/streaming-snapshot-types.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://developer.barchart.com/getting-started/service-types.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
